Create table dialog lists useless data types for SpatiaLite
Status: Closed

Priority: Normal

Assignee:

Category: DB Manager

Affected QGIS version:2.14.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 23019

Description

For SpatiaLite the create table dialog should only list the data types integer, text, real and numeric.

See also: http://www.sqlite.com/datatype3.html (3.2. Affinity Name Examples)

History

#1 - 2016-06-19 10:14 AM - R. R.

- File spatialite_edit_table.png added

#2 - 2016-06-20 05:27 AM - Jukka Rahkonen

I am not sure about this.  While SQLite internally has only few datatypes it is still possible to create a column for example as

ALTER TABLE "foo" 

ADD COLUMN "bar" varchar(20);

Now command PRAGMA table_info('foo') will show

bar    varchar(20)    0    NULL    0

Even is is possible to store almost anything into "bar" the applications can still check the PRAGMA and get to know that they are supposed to save

varchar(20) data into that column. Also, a roundtrip from for example PostGIS into SpatiaLite and back have better possibilities to be successful if

datatypes are copied.

Compare also with GeoPackage which defines all these datatypes:

BOOLEAN, TINYINT, SMALLINT, MEDIUMINT, INT or INTEGER, FLOAT, DOUBLE or REAL, TEXT{(maxchar_count)}, BLOB{(max_size)},

<geometry_type_name>, DATE, DATETIME.

I consider this is not a bug.

I am not a QGIS developer, but some developers in some other projects which I know appreciate if things are first discussed on the mailing list and bug

tickets are created only for issues which are recognized as bugs. Mailing lists are also followed by more people than issue trackers and those people may

enjoy the discussion and learn something by the same.

#3 - 2016-06-20 06:55 AM - R. R.

- File manage_layers_toolbar_new_spatialite_layer.png added
Hi Jukka, the 'New SpatiaLite Layer' dialog only lists the data types 'Text data', 'Whole number' and 'Decimal number' (see attachment). To me this looks

like an inconsistency between the 'Manage Layers Toolbar' and the 'DB Manager'. As mentioned PostGIS and SpatiaLite differ in some points, but the

design of the dialog windows in the 'DB-Manager' is almost identical.

https://issues.qgis.org/attachments/10055/manage_layers_toolbar_new_spatialite_layer.png

#4 - 2016-06-21 12:09 PM - R. R.

Jukka Rahkonen wrote:

I am not a QGIS developer, but some developers in some other projects which I know appreciate if things are first discussed on the mailing list and

bug tickets are created only for issues which are recognized as bugs. Mailing lists are also followed by more people than issue trackers and those

people may enjoy the discussion and learn something by the same.

I agree with that. There is a need for discussion about the SpatiaLite implementation in the 'DB Manager' .

#15082 SpatiaLite index issue

#15079 New PostGIS/SpatiaLite table - Inconsistent behavior of primary keys

Unfortunately I'm not a member of the mailing list at the moment.

#5 - 2016-07-03 11:08 AM - R. R.

- File add_field_attribute_table.png added

The 'Add field' dialog (Attribute table/New field) lists the data types 'Binary object (BLOB)', 'Text', 'Decimal number (double)' and 'Whole number (integer)'.

https://issues.qgis.org/attachments/10126/add_field_attribute_table.png

#6 - 2017-05-01 01:05 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#7 - 2019-03-09 03:08 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release  (LTR) version. This is a major step in our history – a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR  as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the
relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
